Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs	(revision 15017)
@@ -3,5 +3,4 @@
   using Configuration;
   using Core;
-  using Encodings.IntegerVectorEncoding;
   using Expressions;
   using Persistence.Default.CompositeSerializers.Storable;
@@ -12,6 +11,4 @@
     public readonly double Quality;
     [Storable]
-    public readonly IntegerVector IntegerVector;
-    [Storable]
     public readonly IRandom Random;
     [Storable]
@@ -21,11 +18,10 @@
     [Storable]
     protected readonly bool simplify;
-
+    [Storable]
     public PushProgram Program;
 
 
-    public PushSolution(IntegerVector integerVector, double quality, IRandom random, IReadOnlyPushConfiguration config, IPushEvaluator evaluator, bool simplify = false)
+    public PushSolution(PushProgram program, double quality, IRandom random, IReadOnlyPushConfiguration config, IPushEvaluator evaluator, bool simplify = false)
       : base("Solution", "A push solution.") {
-      IntegerVector = integerVector;
       Quality = quality;
       Random = random;
@@ -34,16 +30,12 @@
       this.simplify = simplify;
 
-      InitProgram();
-    }
+      Program = simplify
+        ? Simplifier.Simplifier.Simplify(program, Config, p => Evaluator.EvaluateTraining(Config, p, Random).AvgQuality)
+        : program;
 
-    private void InitProgram() {
-      Program = IntegerVector.ToPushProgram(Config);
-
-      if (simplify)
-        Program = Simplifier.Simplifier.Simplify(Program, Config, p => Evaluator.EvaluateTraining(Config, p, Random).TotalQuality);
     }
 
     public PushSolution(PushSolution origin, Cloner cloner) : base(origin, cloner) {
-      IntegerVector = cloner.Clone(origin.IntegerVector);
+      Program = cloner.Clone(origin.Program);
       Quality = origin.Quality;
       Random = cloner.Clone(origin.Random);
@@ -55,15 +47,9 @@
 
     public virtual PushSolution Simplify() {
-      return new PushSolution(IntegerVector, Quality, Random, Config, Evaluator, true);
+      return new PushSolution(Program, Quality, Random, Config, Evaluator, true);
     }
 
     [StorableConstructor]
     protected PushSolution(bool deserializing) : base(deserializing) { }
-
-    [StorableHook(HookType.AfterDeserialization)]
-    // ReSharper disable once UnusedMember.Local
-    private void AfterDeserialization() {
-      InitProgram();
-    }
 
     public override IDeepCloneable Clone(Cloner cloner) {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Simplifier/Simplifier.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Simplifier/Simplifier.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Simplifier/Simplifier.cs	(revision 15017)
@@ -1,45 +1,52 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Simplifier {
   using System;
-  using System.Collections.Generic;
 
   using Expressions;
 
+  using HeuristicLab.Common;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Tree;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
 
   public static class Simplifier {
     private static readonly TreeNode<Expression> NoopNode =
-      new TreeNode<Expression>(ExpressionTable.GetStatelessExpression<CodeNoopExpression>());
+      new TreeNode<Expression>(ExpressionTable.GetStatelessExpression<ExecNoopExpression>());
 
-    public static PushProgram Simplify(PushProgram program, IReadOnlyPushConfiguration config, Func<PushProgram, double> evaluator) {
+    public static PushProgram Simplify(PushProgram program, IReadOnlyPushConfiguration config, Func<PushProgram, double> evaluator, bool improveIfPossible = false) {
       var bestResult = evaluator(program);
-      //var noopFreeProgram = RemoveNoops(program, config);
       var tree = program.ToTree();
-      var optimizedTree = RemoveUnnecessaryExpressions(tree, tree, ref bestResult, evaluator);
+      var optimizedTree = RemoveUnnecessaryExpressions(tree, tree, ref bestResult, evaluator, improveIfPossible);
+      var tmp = RemoveUnnecessaryExpressions(optimizedTree, optimizedTree, ref bestResult, evaluator, improveIfPossible);
 
-      var optimizedPrgram = optimizedTree.ToPushProgram(e => !ReferenceEquals(e, NoopNode.Value));
-      return optimizedPrgram; // RemoveNoops(optimizedPrgram, config);
+      while (tmp.Count < optimizedTree.Count) {
+        optimizedTree = tmp;
+      }
+
+      var optimizedProgram = optimizedTree.ToPushProgramWithoutNoopExpressions();
+      optimizedProgram = SimplifySubPrograms(optimizedProgram);
+
+      return optimizedProgram;
     }
 
-    // not working so far, an expression can only be a noop if it is a noop for all examples of a problem
-    private static PushProgram RemoveNoops(PushProgram pushProgram, IReadOnlyPushConfiguration config) {
-      var expressions = new List<Expression>();
-      var interpreter = new PushInterpreter(config);
+    public static PushProgram SimplifySubPrograms(PushProgram program) {
+      var tree = program.ToTree();
+      var optimizedTree = SimplifySubPrograms(tree);
+      var optimizedPrgram = optimizedTree.ToPushProgram();
 
-      interpreter.Run(pushProgram, true);
+      return optimizedPrgram;
+    }
 
-      while (interpreter.CanStep) {
-        var isNoop = interpreter.ExecStack.Top.IsNoop(interpreter);
-        if (!isNoop)
-          expressions.Add(interpreter.ExecStack.Top);
+    private static TreeNode<Expression> SimplifySubPrograms(TreeNode<Expression> program) {
+      while (program.Children.Count == 1)
+        program = program.Children[0];
 
-        interpreter.Step();
+      for (var i = 0; i < program.Children.Count; i++) {
+        var child = program.Children[i];
+        program.ReplaceNode(i, SimplifySubPrograms(child));
       }
 
-      return new PushProgram(expressions);
+      return program;
     }
 
-    private static TreeNode<Expression> RemoveUnnecessaryExpressions(Tree<Expression> program, TreeNode<Expression> node, ref double bestResult, Func<PushProgram, double> evaluator) {
+    private static TreeNode<Expression> RemoveUnnecessaryExpressions(TreeNode<Expression> program, TreeNode<Expression> node, ref double bestResult, Func<PushProgram, double> evaluator, bool improveIfPossible = false) {
       for (var i = 0; i < node.Children.Count; i++) {
         var child = node.Children[i];
@@ -49,5 +56,6 @@
         var currentResult = evaluator(currentProgram);
 
-        if (currentResult <= bestResult) {
+        if ((improveIfPossible && currentResult <= bestResult) ||
+            (!improveIfPossible && currentResult.IsAlmost(bestResult))) {
           bestResult = currentResult;
         } else if (child.Value.IsProgram) {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPushStack.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPushStack.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPushStack.cs	(revision 15017)
@@ -4,5 +4,5 @@
 
   public interface IPushStack<T> : ICollection<T>, IPushStack {
-    T Top { get; }
+    T Top { get; set; }
     T TopOrDefault { get; }
     T Bottom { get; }
@@ -23,5 +23,4 @@
     void Insert(int index, T item);
     T ReverseElementAt(int offset);
-    void SetTop(T value);
     T Pop();
     T[] Pop(int count);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/InterpreterStackStringifier.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/InterpreterStackStringifier.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/InterpreterStackStringifier.cs	(revision 15017)
@@ -3,25 +3,28 @@
 
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Stack {
+  using System.Globalization;
+
   using HeuristicLab.Problems.ProgramSynthesis.Push.Constants;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
 
-  public class InterpreterStackStringifier {
+  public static class InterpreterStackStringifier {
 
-    public static IEnumerable<string> StringifyStack(IPushInterpreter interpreter, StackTypes type) {
+    public static IEnumerable<string> StringifyStack(this IPushInterpreter interpreter, StackTypes type) {
       switch (type) {
         case StackTypes.Boolean: return StringifyLiteralStack(interpreter.BooleanStack);
         case StackTypes.Integer: return StringifyLiteralStack(interpreter.IntegerStack);
-        case StackTypes.Float: return StringifyLiteralStack(interpreter.FloatStack);
-        case StackTypes.Char: return StringifyLiteralStack(interpreter.CharStack);
-        case StackTypes.String: return StringifyLiteralStack(interpreter.StringStack, "\"", "\"");
+        case StackTypes.Float: return StringifyFloatStack(interpreter.FloatStack, interpreter.Configuration.FloatStringFormat);
+        case StackTypes.Char: return StringifyCharStack(interpreter.CharStack);
+        case StackTypes.String: return StringifyLiteralStack(interpreter.StringStack, PushEnvironment.StringSymbolStr, PushEnvironment.StringSymbolStr);
         case StackTypes.Name: return StringifyLiteralStack(interpreter.NameStack);
         case StackTypes.Code: return StringifyLiteralStack(interpreter.CodeStack);
         case StackTypes.Exec: return StringifyLiteralStack(interpreter.ExecStack);
-        case StackTypes.Print: return StringifyLiteralStack(interpreter.PrintStack);
+        case StackTypes.Print: return StringifyLiteralStack(interpreter.PrintStack, PushEnvironment.StringSymbolStr, PushEnvironment.StringSymbolStr, false);
 
         case StackTypes.BooleanVector: return StringifyVectorStack(interpreter.BooleanVectorStack);
         case StackTypes.IntegerVector: return StringifyVectorStack(interpreter.IntegerVectorStack);
-        case StackTypes.FloatVector: return StringifyVectorStack(interpreter.FloatVectorStack);
-        case StackTypes.StringVector: return StringifyVectorStack(interpreter.StringVectorStack, "\"", "\"");
+        case StackTypes.FloatVector: return StringifyFloatVectorStack(interpreter.FloatVectorStack, interpreter.Configuration.FloatStringFormat);
+        case StackTypes.StringVector: return StringifyVectorStack(interpreter.StringVectorStack, PushEnvironment.StringSymbolStr, PushEnvironment.StringSymbolStr);
 
         default: return Enumerable.Empty<string>();
@@ -29,9 +32,33 @@
     }
 
-    private static IEnumerable<string> StringifyLiteralStack<T>(IPushStack<T> stack, string prefix = "", string postfix = "") {
-      return stack.Reverse().Select(x => prefix + x.ToString().Replace(PushEnvironment.NewLine, "\\n") + postfix);
+    private static IEnumerable<string> StringifyCharStack(IPushStack<char> stack) {
+      var result = stack.AsEnumerable();
+
+      return result.Select(x => PushEnvironment.CharSymbol + x.Printify() + PushEnvironment.CharSymbol);
     }
 
-    private static IEnumerable<string> StringifyVectorStack<T>(IPushStack<List<T>> stack, string prefix = "", string postfix = "") {
+    private static IEnumerable<string> StringifyFloatStack(IPushStack<double> stack, string format) {
+      var result = stack.AsEnumerable();
+
+      return result.Select(x => x.ToString(format, CultureInfo.InvariantCulture));
+    }
+
+    private static IEnumerable<string> StringifyLiteralStack<T>(IPushStack<T> stack, string prefix = "", string postfix = "", bool reverse = true) {
+      var result = stack.AsEnumerable();
+
+      if (reverse)
+        result = result.Reverse();
+
+      return result.Select(x => prefix + x.ToString() + postfix);
+    }
+
+    private static IEnumerable<string> StringifyFloatVectorStack(IPushStack<IReadOnlyList<double>> stack, string format) {
+      var separator = PushEnvironment.VectorSeparatorSymbol.ToString();
+      return stack
+        .Reverse()
+        .Select(x => PushEnvironment.VectorStartSymbol + string.Join(separator, x.Select(_ => _.ToString(format, CultureInfo.InvariantCulture))) + PushEnvironment.VectorEndSymbol);
+    }
+
+    private static IEnumerable<string> StringifyVectorStack<T>(IPushStack<IReadOnlyList<T>> stack, string prefix = "", string postfix = "") {
       var separator = PushEnvironment.VectorSeparatorSymbol.ToString();
       return stack
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/PushStack.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/PushStack.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/PushStack.cs	(revision 15017)
@@ -43,4 +43,9 @@
         return data[Count - 1];
       }
+
+      set
+      {
+        data[Count - 1] = value;
+      }
     }
 
@@ -119,8 +124,4 @@
     public T ReverseElementAt(int offset) {
       return data[offset];
-    }
-
-    public void SetTop(T value) {
-      data[Count - 1] = value;
     }
 
@@ -276,6 +277,5 @@
 
     public override string ToString() {
-      var data = this.data as IEnumerable<T>;
-      return string.Join(Delimiter, data.Reverse());
+      return string.Join(Delimiter, data.Select(x => x.ToString()).Reverse());
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.Designer.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.Designer.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.Designer.cs	(revision 15017)
@@ -26,27 +26,14 @@
       this.groupBox1 = new System.Windows.Forms.GroupBox();
       this.expressionsTreeView = new System.Windows.Forms.TreeView();
-      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.groupBox1.SuspendLayout();
       this.SuspendLayout();
       //
-      // nameTextBox
-      //
-      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
-      this.nameTextBox.Size = new System.Drawing.Size(244, 20);
-      //
-      // infoLabel
-      //
-      this.infoLabel.Location = new System.Drawing.Point(308, 3);
-      //
       // groupBox1
       //
-      this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
       this.groupBox1.Controls.Add(this.expressionsTreeView);
-      this.groupBox1.Location = new System.Drawing.Point(6, 26);
+      this.groupBox1.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.groupBox1.Location = new System.Drawing.Point(0, 0);
       this.groupBox1.Name = "groupBox1";
-      this.groupBox1.Size = new System.Drawing.Size(318, 426);
+      this.groupBox1.Size = new System.Drawing.Size(327, 455);
       this.groupBox1.TabIndex = 3;
       this.groupBox1.TabStop = false;
@@ -55,11 +42,9 @@
       // expressionsTreeView
       //
-      this.expressionsTreeView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
       this.expressionsTreeView.CheckBoxes = true;
-      this.expressionsTreeView.Location = new System.Drawing.Point(6, 19);
+      this.expressionsTreeView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.expressionsTreeView.Location = new System.Drawing.Point(3, 16);
       this.expressionsTreeView.Name = "expressionsTreeView";
-      this.expressionsTreeView.Size = new System.Drawing.Size(306, 401);
+      this.expressionsTreeView.Size = new System.Drawing.Size(321, 436);
       this.expressionsTreeView.TabIndex = 0;
       //
@@ -71,12 +56,6 @@
       this.Name = "ExpressionSelectionView";
       this.Size = new System.Drawing.Size(327, 455);
-      this.Controls.SetChildIndex(this.nameLabel, 0);
-      this.Controls.SetChildIndex(this.nameTextBox, 0);
-      this.Controls.SetChildIndex(this.infoLabel, 0);
-      this.Controls.SetChildIndex(this.groupBox1, 0);
-      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.groupBox1.ResumeLayout(false);
       this.ResumeLayout(false);
-      this.PerformLayout();
 
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.cs	(revision 15017)
@@ -16,5 +16,5 @@
   [View("Push Expression Selection Editor")]
   [Content(typeof(IEnabledExpressionsConfiguration), true)]
-  public partial class ExpressionSelectionView : NamedItemView {
+  public partial class ExpressionSelectionView : ItemView {
     public ExpressionSelectionView() {
       InitializeComponent();
@@ -57,10 +57,13 @@
           subNode.Checked = e.Node.Checked;
       } else {
-        Content.SetExpression(e.Node.Text, e.Node.Checked, false);
+        Content.SetExpression(e.Node.Text, e.Node.Checked);
         SetStackNodeText(e.Node.Parent);
 
+        // enable/disable stack if no or at least one expression is enabled
         if ((e.Node.Checked && !e.Node.Parent.Checked) ||
-            (!e.Node.Checked && !e.Node.Parent.Nodes.OfType<TreeNode>().Any(n => n.Checked)))
+            (!e.Node.Checked && !e.Node.Parent.Nodes.OfType<TreeNode>().Any(n => n.Checked))) {
+          Content.SetStack(stackType, e.Node.Checked, false, false);
           e.Node.Parent.Checked = e.Node.Checked;
+        }
       }
 
@@ -70,5 +73,4 @@
     protected override void OnContentChanged() {
       expressionsTreeView.Nodes.Clear();
-      nameTextBox.Text = "Push Expression Selection";
 
       if (Content == null) {
@@ -77,6 +79,5 @@
 
       Content.EnabledExpressionsChanged += EnabledExpressionsChanged;
-      var treeNodes = GetTreeNodes(Content.EnabledExpressions).ToArray();
-      expressionsTreeView.Nodes.AddRange(treeNodes);
+      UpdateNodes();
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.Designer.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.Designer.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.Designer.cs	(revision 15017)
@@ -29,7 +29,7 @@
     private void InitializeComponent() {
       System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(PushDebuggerView));
-      this.execGroupBox = new System.Windows.Forms.GroupBox();
-      this.execList = new System.Windows.Forms.ListBox();
       this.debugTableLayout = new System.Windows.Forms.TableLayoutPanel();
+      this.exec2GroupBox = new System.Windows.Forms.GroupBox();
+      this.execTreeView = new HeuristicLab.Problems.ProgramSynthesis.Push.Views.PushProgramTreeView();
       this.stepButton = new System.Windows.Forms.Button();
       this.resetButton = new System.Windows.Forms.Button();
@@ -39,32 +39,8 @@
       this.simplifyButton = new System.Windows.Forms.Button();
       this.execCountLabel = new System.Windows.Forms.Label();
-      this.execGroupBox.SuspendLayout();
       this.debugTableLayout.SuspendLayout();
+      this.exec2GroupBox.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.stepWidthBox)).BeginInit();
       this.SuspendLayout();
-      //
-      // execGroupBox
-      //
-      this.execGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.execGroupBox.AutoSize = true;
-      this.execGroupBox.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
-      this.execGroupBox.Controls.Add(this.execList);
-      this.execGroupBox.Location = new System.Drawing.Point(3, 3);
-      this.execGroupBox.Name = "execGroupBox";
-      this.execGroupBox.Size = new System.Drawing.Size(244, 460);
-      this.execGroupBox.TabIndex = 3;
-      this.execGroupBox.TabStop = false;
-      this.execGroupBox.Text = "Exec";
-      //
-      // execList
-      //
-      this.execList.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.execList.FormattingEnabled = true;
-      this.execList.Location = new System.Drawing.Point(3, 16);
-      this.execList.Name = "execList";
-      this.execList.Size = new System.Drawing.Size(238, 441);
-      this.execList.TabIndex = 0;
       //
       // debugTableLayout
@@ -76,7 +52,8 @@
       this.debugTableLayout.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
       this.debugTableLayout.ColumnCount = 2;
-      this.debugTableLayout.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 250F));
+      this.debugTableLayout.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 350F));
       this.debugTableLayout.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
-      this.debugTableLayout.Controls.Add(this.execGroupBox, 0, 0);
+      this.debugTableLayout.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+      this.debugTableLayout.Controls.Add(this.exec2GroupBox, 0, 0);
       this.debugTableLayout.Location = new System.Drawing.Point(3, 3);
       this.debugTableLayout.Name = "debugTableLayout";
@@ -85,4 +62,23 @@
       this.debugTableLayout.Size = new System.Drawing.Size(872, 466);
       this.debugTableLayout.TabIndex = 18;
+      //
+      // exec2GroupBox
+      //
+      this.exec2GroupBox.Controls.Add(this.execTreeView);
+      this.exec2GroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.exec2GroupBox.Location = new System.Drawing.Point(3, 3);
+      this.exec2GroupBox.Name = "exec2GroupBox";
+      this.exec2GroupBox.Size = new System.Drawing.Size(344, 460);
+      this.exec2GroupBox.TabIndex = 4;
+      this.exec2GroupBox.TabStop = false;
+      this.exec2GroupBox.Text = "Exec";
+      //
+      // execTreeView
+      //
+      this.execTreeView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.execTreeView.Location = new System.Drawing.Point(3, 16);
+      this.execTreeView.Name = "execTreeView";
+      this.execTreeView.Size = new System.Drawing.Size(338, 441);
+      this.execTreeView.TabIndex = 0;
       //
       // stepButton
@@ -187,7 +183,6 @@
       this.Name = "PushDebuggerView";
       this.Size = new System.Drawing.Size(878, 504);
-      this.execGroupBox.ResumeLayout(false);
       this.debugTableLayout.ResumeLayout(false);
-      this.debugTableLayout.PerformLayout();
+      this.exec2GroupBox.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.stepWidthBox)).EndInit();
       this.ResumeLayout(false);
@@ -197,7 +192,4 @@
 
     #endregion
-
-    private GroupBox execGroupBox;
-    private ListBox execList;
     private TableLayoutPanel debugTableLayout;
     private Button stepButton;
@@ -208,4 +200,6 @@
     private Button simplifyButton;
     private Label execCountLabel;
+    private GroupBox exec2GroupBox;
+    private PushProgramTreeView execTreeView;
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.cs	(revision 15017)
@@ -15,5 +15,6 @@
 
   public partial class PushDebuggerView : ItemView {
-    private readonly IDictionary<StackTypes, ListBox> debugControlDict = new Dictionary<StackTypes, ListBox>();
+    private readonly IDictionary<StackTypes, ListBox> debugListDict = new Dictionary<StackTypes, ListBox>();
+    private readonly IDictionary<StackTypes, PushProgramTreeView> debugPushProgramDict = new Dictionary<StackTypes, PushProgramTreeView>();
 
     private PooledPushInterpreter interpreter;
@@ -157,22 +158,21 @@
 
     private void ClearDebugLists() {
-      foreach (var list in debugControlDict.Values) {
+      foreach (var list in debugListDict.Values) {
         list.Items.Clear();
       }
+
+      foreach (var treeView in debugPushProgramDict.Values) {
+        treeView.Nodes.Clear();
+      }
     }
 
     private void UpdateExecList() {
-      execList.Items.Clear();
-      var expressions = interpreter.ExecStack.AsEnumerable()
-        .Reverse()
-        .Select(e => e.StringRepresentation)
-        .ToArray();
-
-      execList.Items.AddRange(expressions);
-      execGroupBox.Text = string.Format(GROUP_BOX_TEXT_STRING_FORMAT, Enum.GetName(typeof(StackTypes), StackTypes.Exec), interpreter.ExecStack.Count);
+      execTreeView.LoadExpressions(interpreter.ExecStack.Reverse());
+      exec2GroupBox.Text = string.Format(GROUP_BOX_TEXT_STRING_FORMAT, Enum.GetName(typeof(StackTypes), StackTypes.Exec), interpreter.ExecStack.Count);
     }
 
     private void InitDebugLists(IReadOnlyPushConfiguration config) {
-      debugControlDict.Clear();
+      debugListDict.Clear();
+      debugPushProgramDict.Clear();
 
       // 2 = ExecList + EmptyColumn which is required to fill empty space
@@ -185,18 +185,41 @@
         if (stackType != StackTypes.Exec &&
             ExpressionTable.GetExpressionsByStackTypes(stackType).Intersect(config.EnabledExpressions).Any()) {
-          var list = CreateDebugList(stackType);
-          debugControlDict.Add(stackType, list);
+
+          switch (stackType) {
+            case StackTypes.Code:
+              var treeView = CreatePushProgramTreeView(stackType);
+              debugPushProgramDict.Add(stackType, treeView);
+              break;
+            default:
+              var list = CreateDebugList(stackType);
+              debugListDict.Add(stackType, list);
+              break;
+          }
         }
       }
     }
 
+    private PushProgramTreeView CreatePushProgramTreeView(StackTypes type) {
+
+      var treeView = new PushProgramTreeView {
+        Dock = DockStyle.Fill
+      };
+
+      AddStackControlToTableLayout(type, treeView, 400);
+
+      return treeView;
+    }
+
+    private void AddStackControlToTableLayout(StackTypes type, Control control, int width) {
+      var groupBox = CreateStackGroupBox(type);
+      groupBox.Controls.Add(control);
+
+      debugTableLayout.ColumnCount++;
+      debugTableLayout.ColumnStyles.Insert(1, new ColumnStyle(SizeType.Absolute, width));
+      debugTableLayout.Controls.Add(groupBox);
+      debugTableLayout.Controls.SetChildIndex(groupBox, 1);
+    }
+
     private ListBox CreateDebugList(StackTypes type) {
-      var groupBox = new GroupBox {
-        Anchor = AnchorStyles.Bottom | AnchorStyles.Right | AnchorStyles.Left | AnchorStyles.Top,
-        AutoSize = true,
-        AutoSizeMode = AutoSizeMode.GrowAndShrink,
-        Text = Enum.GetName(typeof(StackTypes), type)
-      };
-
       var list = new ListBox {
         Dock = DockStyle.Fill
@@ -227,16 +250,17 @@
       }
 
-      groupBox.Controls.Add(list);
-
-      var columnWidth = stackEntryType == typeof(Expression) ? 250 : 150;
-
-      debugTableLayout.ColumnCount++;
-      debugTableLayout.ColumnStyles.Insert(1, new ColumnStyle(SizeType.Absolute, columnWidth));
-      debugTableLayout.Controls.Add(groupBox);
-      debugTableLayout.Controls.SetChildIndex(groupBox, 1);
+      AddStackControlToTableLayout(type, list, 150);
 
       return list;
     }
 
+    private static GroupBox CreateStackGroupBox(StackTypes type) {
+      return new GroupBox {
+        Anchor = AnchorStyles.Bottom | AnchorStyles.Right | AnchorStyles.Left | AnchorStyles.Top,
+        AutoSize = true,
+        AutoSizeMode = AutoSizeMode.GrowAndShrink,
+        Text = Enum.GetName(typeof(StackTypes), type)
+      };
+    }
 
     private void UpdateDebugLists() {
@@ -246,7 +270,15 @@
         return;
 
-      foreach (var pair in debugControlDict) {
+      foreach (var pair in debugPushProgramDict) {
         var name = Enum.GetName(typeof(StackTypes), pair.Key);
-        var items = InterpreterStackStringifier.StringifyStack(interpreter, pair.Key).ToArray();
+        var stack = (IPushStack<Expression>)interpreter.Stacks[pair.Key];
+
+        pair.Value.AddExpressions(stack);
+        ((GroupBox)pair.Value.Parent).Text = string.Format(GROUP_BOX_TEXT_STRING_FORMAT, name, pair.Value.Nodes.Count);
+      }
+
+      foreach (var pair in debugListDict) {
+        var name = Enum.GetName(typeof(StackTypes), pair.Key);
+        var items = interpreter.StringifyStack(pair.Key).ToArray();
 
         pair.Value.Items.AddRange(items);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramTreeView.Designer.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramTreeView.Designer.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramTreeView.Designer.cs	(revision 15017)
@@ -0,0 +1,32 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Views {
+  partial class PushProgramTreeView {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      components = new System.ComponentModel.Container();
+      //this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+    }
+
+    #endregion
+  }
+}
